package com.xynet.marketing.entity;

import com.baomidou.mybatisplus.annotation.*;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

/**
 * 商家优惠券表
 *
 * @author hechunping
 * @date 2025/2/10
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@TableName("marketing_merc_coupon")
public class MercCoupon implements Serializable {

    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 商户id
     */
    private Integer mercId;

    /**
     * 优惠券名称
     */
    private String name;

    private Boolean isAllDevice = true;

    private Boolean isAllGoods = true;

    private String validType;

    private Integer validDay;

    private LocalDateTime validStartDate;

    private LocalDateTime validEndDate;

    private Integer useMinPrice;

    private String type;

    private String price;

    private String status;

    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;

    @TableField(fill = FieldFill.UPDATE)
    private LocalDateTime updateTime;

    private String sendType;

    private String sendConfig;

    private LocalDate sendStartDate;

    private LocalDate sendEndDate;

}
